
TACHYON

{ PIR.fth - Passive Infra-Red Sensor

  UPDATED:  120820.1200 - BBR - corrected INPUT statement and associated logic
  CREATED:  120819.1900 - Brian Riley - Underhill Center, VT, USA
  BASEDON:  080603.0000 - Joshua Donelson - Parallax

          Parallax PIR Sensor module(#555-28027)

   PIR senses movement and temperature changes within a proximity of about 20 feet.

       PIR SENSOR 
  ┌───────────────────┐
  │     ┌───────┐     │    :: Connection To Propeller ::
  │     │   ‣   │     │        1 - Ground
  │     └───────┘     │        2 - Either 5 or 3.3 VDC (5 VDC in this example)
  │    GND +5V SIG    │        3 - Signal to Input PIN with 1kΩ resistor
  └─────┬───┬───┬─────┘                                                 
        │  │    1K
          └┘   └ Pin

}


: PIRSTART   ( lpin -- )			\ sets 30 second period for sensor to 'warm up'

        MASK 						\ pinmask
   		#30 0 DO 					\ Thirty (30)  1 sec loops toggling Warm-up LED
			DUP OUTSET #500 ms
			DUP OUTCLR #500 ms
		LOOP
		;
		
: PIR        ( lpin dpin -- )

		DUP MASK INPUTS				\ datpin, save, pinmask, declare input
		SWAP MASK DUP OUTCLR		\ bring PIR detect LEDpin fwd, pinmask, save, set to LOW
		SWAP						\ swap LEDpin to the back
		
		BEGIN		\ begin loop
			DUP INPUT IF		  		 \ read PIR data if NEZ
				SWAP DUP OUTSET #67 ms   \ swap LEDpin fwd set pin HIGH, wait
				DUP OUTCLR #67 ms		 \ set LEDpin to LOW wait
				SWAP					 \ swap PIR data to front again ready for next input
			THEN
		AGAIN		\ 'again' is same as FALSE UNTIL - infinite loop
		;
			
END
